﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
    
// Дополнительные пространства имен
using System.Data.OleDb;
using System.Data.Common;
    
namespace WinForms1
{
    public partial class Form1 : Form
    {
        // Объявили поля-ссылки для видимости в методах
        TabControl tabControl;
        DataTable schemaTable;
        ComboBox cbCollections, cbTables;
        DataGridView dataGridView1, dataGridView2;
    
        // Конструктор формы
        public Form1()
        {
            InitializeComponent();
            this.Text = "Упражнение 1. Извлечение метаданных";
            this.WindowState = FormWindowState.Maximized;
    
            CreateControl();// Динамически создать пользовательский интерфейс
            // Загрузить списки во вкладках
            LoadCollections();
            LoadTables();
    
            CreateControl1();// Динамически создать пользовательский интерфейс
            // Загрузить список в новой вкладке
            LoadTables1();
        }
    
        // Имя метода пересекается с наследуемым (для разнообразия)
        new void CreateControl()
        {
            // Динамическое создание элементов управления
            tabControl = new TabControl();
            this.Controls.Add(tabControl);
            tabControl.Dock = DockStyle.Fill;
            TabPage page1 = new TabPage("Коллекции");
            tabControl.TabPages.Add(page1);// Добавили вкладку
            TabPage page2 = new TabPage("Таблицы");
            //tabControl.TabPages.Add(page2);// Добавили вкладку
            page2.Parent = tabControl;// Добавили вкладку (равноценно!!!)
    
            // Для динамического выравнивания элементов на первой вкладке
            TableLayoutPanel layoutPanel1 = new TableLayoutPanel();
            page1.Controls.Add(layoutPanel1);// Добавили панель к вкладке
            layoutPanel1.Dock = DockStyle.Fill;
    
            // Для динамического выравнивания элементов на второй вкладке
            TableLayoutPanel layoutPanel2 = new TableLayoutPanel();
            page2.Controls.Add(layoutPanel2);// Добавили панель к вкладке
            layoutPanel2.Dock = DockStyle.Fill;
    
            cbCollections = new ComboBox();
            cbCollections.Dock = DockStyle.Fill;
            layoutPanel1.Controls.Add(cbCollections);// Добавили список к панели
            // Зарегистрировали обработчик для первого списка
            cbCollections.SelectedIndexChanged += cbCollections_SelectedIndexChanged;
    
            // Объект отображения данных
            dataGridView1 = new DataGridView();// Создаем
            layoutPanel1.Controls.Add(dataGridView1);// Добавили сетку к панели
            dataGridView1.Dock = DockStyle.Fill;
            dataGridView1.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.Fill;
    
            cbTables = new ComboBox();
            cbTables.Dock = DockStyle.Fill;
            layoutPanel2.Controls.Add(cbTables);// Добавили список к панели
            // Зарегистрировали обработчик для второго списка
            cbTables.SelectedIndexChanged += cbTables_SelectedIndexChanged;
    
            // Объект отображения данных
            dataGridView2 = new DataGridView();// Создаем
            layoutPanel2.Controls.Add(dataGridView2);// Добавили сетку к панели
            dataGridView2.Dock = DockStyle.Fill;
            dataGridView2.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.Fill;
        }
    
        // Строка соединения к БД с абсолютным путем, определяемым сборкой
        String ConnectionString()
        {
            // Используем построитель строки подключения 
            OleDbConnectionStringBuilder objConnectionStringBuilder =
                new OleDbConnectionStringBuilder();
            objConnectionStringBuilder.Provider = "Microsoft.Jet.OLEDB.4.0";
            objConnectionStringBuilder.DataSource =
                Application.StartupPath.ToString() + @"\Data\Northwind.mdb";
    
            return objConnectionStringBuilder.ToString();
        }
    
        // Извлекаем в список имена всех коллекция БД
        void LoadCollections()
        {
            using (OleDbConnection connection = new
                     OleDbConnection(ConnectionString()))
            {
                connection.Open();
                schemaTable = connection.GetSchema();
            }
    
            foreach (DataRow row in schemaTable.Rows)
            {
                Object col = row["CollectionName"].ToString();
                cbCollections.Items.Add(col);
            }
    
            // Несвязанный список, можно сортировать
            cbCollections.Sorted = true;
            cbCollections.SelectedIndex = 0;
        }
    
        // Заполняем список именами таблиц БД
        void LoadTables()
        {
            // Создали, заполнили, скопировали в список и потеряли
            DataTable table = new DataTable();// Локальная ссылка на объект
    
            // Соединение закрывается после выхода из инструкции using
            using (OleDbConnection connection = new
                       OleDbConnection(ConnectionString()))
            {
                connection.Open();
                // Выбираем коллекцию только для таблиц
                table = connection.GetOleDbSchemaTable(
                    OleDbSchemaGuid.Tables,
                    new object[] { null, null, null, "TABLE" });
            }
    
            // Значения столбца TABLE_NAME скопировали в ComboBox
            foreach (DataRow row in table.Rows)
            {
                Object col = row["TABLE_NAME"].ToString();
                cbTables.Items.Add(col);
            }
    
            // Несвязанный список, можно сортировать
            cbTables.Sorted = true;
            cbTables.SelectedIndex = 0;// Установили список в начало
        }
    
        // Извлекаем информацию о выделенной коллекции
        void cbCollections_SelectedIndexChanged(object sender, EventArgs e)
        {
            schemaTable.Clear();// Очистим от предыдущего
            using (OleDbConnection connection = new
                       OleDbConnection(ConnectionString()))
            {
                connection.Open();
                schemaTable = connection.GetSchema(cbCollections.SelectedItem.ToString());
            }
            // Связываем таблицу и элемент отображения
            dataGridView1.DataSource = schemaTable;
        }
    
        // Извлекаем информацию о выделенной таблице
        void cbTables_SelectedIndexChanged(object sender, EventArgs e)
        {
            // Все ссылки стековые
            String selectCommand = "";
            String tableName = cbTables.SelectedItem.ToString();
            if (tableName.IndexOf(' ') != -1)// Для таблицы 'Order Details'
                selectCommand = "SELECT * FROM " + "[" + tableName + "]";
            else
                selectCommand = "SELECT * FROM " + tableName;
            OleDbConnection connection = new OleDbConnection(ConnectionString());
            OleDbCommand objCommand = new OleDbCommand(selectCommand, connection);
    
            using (connection)// Заключаем в блок автоматического закрытия соединения при аварии
            {
                connection.Open();
                // Выполняем объект DbCommand одним из его методов
                OleDbDataReader dataReader = objCommand.ExecuteReader();
                // Извлечь метаданные таблицы и сразу привязать для показа
                dataGridView2.DataSource = dataReader.GetSchemaTable();
                connection.Close();
            }
        }
    }
}
