﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
    
// Дополнительные пространства имен
using System.Data.OleDb;
using System.Data.Common;
    
namespace WinForms1
{
    partial class Form1
    {
        // Объявили поля-ссылки для видимости в методах
        ComboBox cbTables1;
        DataGridView dataGridView;
    
        // Создаем вкладку и ее элементы
        void CreateControl1()
        {
            // Динамическое создание элементов управления
            TabPage page = new TabPage("Данные");
            tabControl.TabPages.Add(page);// Добавили вкладку
    
            // Для динамического выравнивания элементов
            TableLayoutPanel layoutPanel = new TableLayoutPanel();
            page.Controls.Add(layoutPanel);// Добавили панель к вкладке
            layoutPanel.Dock = DockStyle.Fill;
    
            cbTables1 = new ComboBox();
            cbTables1.Dock = DockStyle.Fill;
            layoutPanel.Controls.Add(cbTables1);// Добавили список к панели
            // Зарегистрировали обработчик для списка
            cbTables1.SelectedIndexChanged += cbTables1_SelectedIndexChanged;
    
            // Объект отображения данных
            dataGridView = new DataGridView();// Создаем
            layoutPanel.Controls.Add(dataGridView);// Добавили сетку к панели
            dataGridView.Dock = DockStyle.Fill;
            dataGridView.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.Fill;
        }
    
        // Заполняем список именами таблиц БД
        void LoadTables1()
        {
            // Создали, заполнили, скопировали в список и потеряли
            DataTable table = new DataTable();// Локальная ссылка на объект
    
            // Соединение закрывается после выхода из инструкции using
            using (OleDbConnection connection = new
                       OleDbConnection(ConnectionString()))
            {
                connection.Open();
                // Выбираем коллекцию только для таблиц
                table = connection.GetOleDbSchemaTable(
                    OleDbSchemaGuid.Tables,
                    new object[] { null, null, null, "TABLE" });
            }
    
            // Значения столбца TABLE_NAME скопировали в ComboBox
            foreach (DataRow row in table.Rows)
            {
                Object tableName = row["TABLE_NAME"].ToString();
                cbTables1.Items.Add(tableName);
            }
    
            // Несвязанный список, можно сортировать
            cbTables1.Sorted = true;
            cbTables1.SelectedIndex = 0;// Установили список в начало
        }
    
        // Извлекаем все данные выделенной таблицы
        void cbTables1_SelectedIndexChanged(object sender, EventArgs e)
        {
            // Все ссылки стековые
            String selectCommand = "";
            String tableName = cbTables1.SelectedItem.ToString();
            if (tableName.IndexOf(' ') != -1)// Для таблицы 'Order Details'
                selectCommand = "SELECT * FROM " + "[" + tableName + "]";
            else
                selectCommand = "SELECT * FROM " + tableName;
            OleDbConnection connection = new OleDbConnection(ConnectionString());
            OleDbCommand objCommand = new OleDbCommand(selectCommand, connection);
            OleDbDataAdapter adapter = new OleDbDataAdapter(objCommand);
            DataTable dataTable=new DataTable();
            adapter.Fill(dataTable);
            dataGridView.DataSource = dataTable;
        }
    }
}
