﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
       
// Дополнительные пространства имен
using System.Data.OleDb;
using System.Data.Common;
    
namespace WinForms3
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            // Инициализировать созданное в режиме дизайнера
            InitializeComponent();
            this.WindowState = FormWindowState.Maximized;// На полный экран
    
            //MaxPrimaryKey();// Максимальное значение ключа!!!
    
            // Создать все остатки от дизайнера и загрузить таблицу
            LoadProducts();
            // Перед закрытием формы проверяем несохраненные изменения
            this.FormClosing += new FormClosingEventHandler(Form1_FormClosing);
        }
    
        // Максимальное значение ключа
        void MaxPrimaryKey()
        {
            OleDbConnection conn = new OleDbConnection(ConnectionString());
            OleDbCommand command = new OleDbCommand(
//                "SELECT MAX(ProductID) FROM Products",
                "SELECT COUNT(*) FROM Products",
                conn);
    
            conn.Open();
            int max = (int)command.ExecuteScalar();
            conn.Close();
    
            MessageBox.Show(max.ToString());
        }
    
        // Проверяем при закрытии формы несохраненные изменения
        void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if(tableProducts.GetChanges() != null)
            {
                DialogResult result =
                   MessageBox.Show("Вы не сохранили изменения в БД\nСохранить?",
                   "Внимание!",
                   MessageBoxButtons.YesNoCancel, MessageBoxIcon.Warning);
                if (result == DialogResult.Yes)
                    Update();   // Сохраняем данные
                else if (result == DialogResult.Cancel)
                    e.Cancel = true;// Отменяем закрытие формы
            }
        }
    
        // Строка соединения к БД с абсолютным путем, определяемым сборкой
        String ConnectionString()
        {
            // Используем построитель строки подключения 
            OleDbConnectionStringBuilder objConnectionStringBuilder =
                new OleDbConnectionStringBuilder();
            objConnectionStringBuilder.Provider = "Microsoft.Jet.OLEDB.4.0";
            objConnectionStringBuilder.DataSource =
                Application.StartupPath.ToString() + @"\Data\Northwind.mdb";
                //Application.ExecutablePath + @"\Data\Northwind.mdb";// + имя сборки
    
            return objConnectionStringBuilder.ToString();
        }
    
        // Выносим в поля для видимости в методах
        DataTable tableProducts;
        OleDbDataAdapter adapter;
    
        // Все загружаем и все настраиваем
        void LoadProducts()
        {
            // Загружаем таблицу Products целиком
            OleDbConnection connection = new OleDbConnection(ConnectionString());
            adapter = new OleDbDataAdapter(
                new OleDbCommand("SELECT * FROM Products", connection));
            tableProducts = new DataTable();// Имя можно не указывать!
    
            // Регистрируем обработчик события изменения поля таблицы для
            // выделения ячейки после редактирования через DataGridView
            tableProducts.ColumnChanged += 
                new DataColumnChangeEventHandler(tableProducts_ColumnChanged);
    
            // Указать столбец с автозаполнением, но обязательно до включения в таблицу
            DataColumn col = new DataColumn("ProductID", typeof(int));
            col.AutoIncrement = true;
            tableProducts.Columns.Add(col);
            col.ReadOnly = true;// Ключевой столбец не дать редактировать напрямую
    
            adapter.Fill(tableProducts);// Сам откроет соединение и сам закроет
            // Указать первичный ключ можно уже и в заполненной таблице
            // Синтаксис определения первичного ключа требует использовать массив
            // на случай, если в первичный ключ войдут несколько столбцов 
            tableProducts.PrimaryKey =
                new DataColumn[] { tableProducts.Columns["ProductID"] };
    
            // 
            // Разветвитель, навигатор и сетку создали визуально
            //
            // Связали таблицу с разветвителем
            bindingSource.DataSource = tableProducts;
            // Поключили к разветвителю навигатор
            bindingNavigator.BindingSource = bindingSource;
            // Подключили к разветвителю элемент редактирования
            dataGridView.DataSource = bindingSource;
    
            //
            //Настраиваем DataGridView
            //
            // Сделаем ключевой столбец с автозаполнением только для чтения
            //dataGridView.Columns["ProductID"].ReadOnly = true;// Уже сделали в таблице
            // Ширина столбцов по ширине содержимого
            dataGridView.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells;
            dataGridView.RowHeadersWidth = 25;// Ширина первого (служебного) столбца
            //dataGridView.RowHeadersVisible = false;// Скрываем первый (служебный) столбец        
            //dataGridView.Columns["ProductID"].Visible = false;// Скрываем рабочий столбец
    
            // Запретим выделение многих строк, все-равно 
            // навигатор удаляет только по одной строке
            dataGridView.MultiSelect = false;
    
            // Настраиваем стиль строки заголовков сетки
            DataGridViewCellStyle columnHeaderStyle = new DataGridViewCellStyle();// Создали стиль
            columnHeaderStyle.BackColor = Color.Beige;// Цвет фона заголовка
            columnHeaderStyle.Font = new Font("Verdana", 10, FontStyle.Bold);// Шрифт
            columnHeaderStyle.Alignment = 
                DataGridViewContentAlignment.MiddleCenter;// Выравнивать по центру столбца
            dataGridView.ColumnHeadersDefaultCellStyle = columnHeaderStyle;// Настроили и прицепили 
            // Фоновый цвет всех ячеек таблицы по умолчанию белый. Но явно
            // задаем потому, что позже будем восстанавливать белым же цветом
            DataGridViewCellStyle defaultCellStyle = new DataGridViewCellStyle();
            defaultCellStyle.BackColor = Color.White;
            dataGridView.DefaultCellStyle = defaultCellStyle;// Настроили и прицепили
    
            //
            // Настраиваем кнопки объекта BindingNavigator здесь
            // или в панели Properties дизайнера
            //
            bindingNavigatorMoveFirstItem.ToolTipText = "На первую запись";
            bindingNavigatorMovePreviousItem.ToolTipText = "На предыдущую запись";
            bindingNavigatorPositionItem.ToolTipText = "Текущая запись";
            bindingNavigatorCountItem.ToolTipText = "Всего записей";
            bindingNavigatorMoveNextItem.ToolTipText = "На следующую запись";
            bindingNavigatorMoveLastItem.ToolTipText = "На последнюю запись";
            bindingNavigatorAddNewItem.ToolTipText = "Добавить запись";
            bindingNavigatorDeleteItem.ToolTipText = "Удалить запись";
            saveToolStripButton.ToolTipText = "Сохранить изменения";
            helpToolStripButton.ToolTipText = "Помощь";
            helpToolStripButton.Enabled = false;// Затычка для Справки, пока не хотим...
            // Регистрируем обработчик события сохранения данных в БД
            saveToolStripButton.Click += new EventHandler(saveToolStripButton_Click);
    
            //
            // Создаем и настраиваем контекстное меню для дополнительных команд
            //
            // Создаем объект контекстного меню
            System.Windows.Forms.ContextMenuStrip menu = new ContextMenuStrip();
            // Прицепляем к DataGridView
            dataGridView.ContextMenuStrip = menu;
            // Создаем объект команды и сразу с названием
            ToolStripMenuItem item = new ToolStripMenuItem("Восстановить");
            // Всплывающая подсказка
            item.ToolTipText = "Откатить все несохраненные изменения";
            // Добавляем команду в коллекцию команд контекстного меню
            menu.Items.Add(item);
            // Регистрируем обработчик команды для события Click
            item.Click += new EventHandler(item_RestoreClick);
        }
    
        // Список для хранения ячеек с измененными стилями
        // для последующего восстановления в ClearStyleModifiedCells()
        // (Ничего приличнее мне в голову не пришло! НаноСидоркин - помоги!
        // Надо искать оптовое решение в самом DataGridView)
        System.Collections.ArrayList listCell = new System.Collections.ArrayList();
    
        // Срабатывает при модификации любого поля
        void tableProducts_ColumnChanged(object sender, DataColumnChangeEventArgs e)
        {
            DataGridViewCellStyle style = new DataGridViewCellStyle();
            style.BackColor= Color.Aqua;
            dataGridView.CurrentCell.Style = new DataGridViewCellStyle(style);
            listCell.Add(dataGridView.CurrentCell);// Складываем ссылки для восстановления
        }
    
        // Обработчик команды контекстного меню
        void item_RestoreClick(object sender, EventArgs e)
        {
            // Если нечего откатывать
            if (tableProducts.GetChanges() == null)
                return;
    
            // Есть изменения, спрашиваем желание пользователя
            DialogResult result =
                MessageBox.Show("Вы действительно хотите откатить\n"
                + "последние несохраненные изменения?",
                "Внимание!",
                MessageBoxButtons.YesNo, MessageBoxIcon.Warning);
            if (result == DialogResult.Yes)
            {
                tableProducts.RejectChanges();// Откатываем таблицу
                ClearStyleModifiedCells(); // Снимаем выделение с ячеек
            }
        }
    
        // Сохраняем изменения в БД
        new void Update()
        {
            // Чтобы лишний раз не дергать проверку на уровне БД
            if (tableProducts.GetChanges() == null)
                return;
    
            // Создаем построитель команд по настройкам нашего адаптера
            OleDbCommandBuilder commandBuilder =
                new OleDbCommandBuilder(adapter);
            // Не реагировать на конфликты параллелизма, а записывать поверх
            commandBuilder.ConflictOption = ConflictOption.OverwriteChanges;
            // Отправить изменения таблицы в БД. Необходимые 
            // команды генерирует созданный объект commandBuilder
            adapter.Update(tableProducts);
        }
    
        // Обработчик кнопки сохранения изменений в БД
        void saveToolStripButton_Click(object sender, EventArgs e)
        {
            // Проверка достоверности завершает редактирование текушего поля
            this.Validate();        
            bindingSource.EndEdit();// Останавливаем разветвитель
    
            Update();// Отправляем изменения в БД
            ClearStyleModifiedCells();// Восстанавливаем цвет ячеек сетки
        }
    
        // Все содержимое ArrayList имеет тип Object - надо явно приводить
        void ClearStyleModifiedCells()
        {
            // Снимаем выделение с измененных ячеек сетки
            DataGridViewCellStyle style = new DataGridViewCellStyle();
            style.BackColor = Color.White;
            foreach (Object ob in listCell)
            {
                if (ob != null)// На случай, если строку с ячейками удалили!
                    ((DataGridViewCell)ob).Style = new DataGridViewCellStyle(style);
            }
    
            listCell.Clear();// Очистить список, начать с чистого листа!
        }
    }
}