﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
    
// Дополнительные пространства имен
using System.Data.OleDb;
using System.Data.Common;
using System.Xml;
using System.IO;
    
namespace WinForms5
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
    
            SetInterface();
            Load();
        }
    
        WebBrowser browser;
        DataGridView dataGridView;
        void SetInterface()
        {
            this.Text = "Упражнение 5";
            // Создаем сплиттер
            SplitContainer split = new SplitContainer();
            split.Orientation = Orientation.Horizontal;
            split.Dock = DockStyle.Fill;
            split.Parent = this;
    
            // Создаем элементы отображения
            dataGridView = new DataGridView();
            dataGridView.Dock = DockStyle.Fill;
            dataGridView.AutoSizeColumnsMode = 
                DataGridViewAutoSizeColumnsMode.Fill;
            dataGridView.RowHeadersWidth = 25;// Служебный столбец
            dataGridView.Parent = split.Panel1;
            browser = new WebBrowser();
            browser.Dock = DockStyle.Fill;
            browser.Parent = split.Panel2;
        }
    
        DataSet LoadDataSet()
        {
            // Извлекаем строку соединения из файла App.config
            String connectStr = System.Configuration.
                ConfigurationManager.ConnectionStrings["MyNorthwind"].ConnectionString;
    
            DataSet ds = new DataSet();
    
            // Заполняем множественный набор данных из БД
            using (OleDbConnection conn = new OleDbConnection(connectStr))
            {
                OleDbCommand selectCommand = conn.CreateCommand();// Команда получила соединение
                OleDbDataAdapter adapter = new OleDbDataAdapter(selectCommand);
    
                // Загружает данные и схему первой таблицы
                selectCommand.CommandText = "SELECT EmployeeID, " +
                    "(LastName + ', ' + FirstName) AS FullName, " + 
                    "Address, BirthDate, Region FROM Employees";
                adapter.Fill(ds);
            }
    
            return ds;
        }
    
        XmlDataDocument document;
        String path;
        new void Load()
        {
            // Определяем полный путь к хранилищу данных
            path = Application.StartupPath.ToString() + @"\Data\";
            // Создаем Xml-документ и загружаем его данными
            document = new XmlDataDocument(LoadDataSet());
            // Связываем с сеткой для отображения
            dataGridView.DataSource = document.DataSet;// Только для чтения
            dataGridView.DataMember = "Table";// Дежурное имя, когда не задано явно
    
            // Все тонкие ссылки можно объявить типом 
            // ближайшего абстрактного предка (просто так!)
            TextWriter tw = new StringWriter();// Создали поток записи
            document.Save(tw); ;// Сохраняем документ в потоке 
            document.Save(path + "XmlDataDocument.xml");// Сохранили в файле
    
            // Выводим в консольное окно
            TextReader tr = new StringReader(tw.ToString());// Создали поток чтения
            String str = tr.ToString();// Если ничего нет, то будет null
            while (str != null)
            {
                str = tr.ReadLine();
                Console.WriteLine(str);
            }
    
            browser.Navigate(path + "XmlDataDocument.xml");
    
            // Регистрируем обработчик события редактирования строки
            document.DataSet.Tables[0].RowChanged += 
                new DataRowChangeEventHandler(Form1_RowChanged);
        }
    
        void Form1_RowChanged(object sender, DataRowChangeEventArgs e)
        {
            document.Save(path + "XmlDataDocument.xml");
            browser.Navigate(path + "XmlDataDocument.xml");
        }
    }
}